import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.lang.acl.ACLMessage;

public class Azafata extends Agent {
	
	class ComienzoAzafata extends CyclicBehaviour
	{
		public void action()
		{
			ACLMessage msg = receive();
			if (msg != null) 
			{
				if (msg.getPerformative() == ACLMessage.INFORM) 
				{
					String content = msg.getContent();
					if ((content != null)
							&& (content.indexOf("Comienzo") != -1)) 
					{
						// Recibido un INFORM con contenido correcto
						System.out.println("Azafata: Abrochense los cinturones, y si desean algo, ¡llamenme!");
						addBehaviour(new DrinkAsked(this.getAgent(),this));
					} else 
					{
					// Recibida una performativa incorrecta
					System.out.println("No entiendo, soy rubia");
					}
				}
			}
		}
	} 
	
	class DrinkAsked extends SimpleBehaviour {

		private boolean finished = false;
		CyclicBehaviour lastbehaviour;

		public DrinkAsked(Agent a, CyclicBehaviour b) {
			super(a);
			lastbehaviour = b;
		}

		public void onStart()
		{
			removeBehaviour(lastbehaviour);
		}
		
		public void action() {
			ACLMessage msg = receive();
			if (msg != null) {
				if (msg.getPerformative() == ACLMessage.NOT_UNDERSTOOD || msg.getPerformative() == ACLMessage.INFORM) {
					;
				} else {
					ACLMessage reply = msg.createReply();
					if (msg.getPerformative() == ACLMessage.QUERY_REF) {
						String content = msg.getContent();
						if ((content != null)
								&& (content.indexOf("Chupito") != -1)) {
							System.out
									.println("Azafata: Marchando un chupito de Jagger!");
							reply.setPerformative(ACLMessage.INFORM);
							reply.setContent("Chupito");
						} else {
							System.out
									.println("Azafata: ¿Has bebido demasiado? ¡No te entiendo!");
							reply.setPerformative(ACLMessage.NOT_UNDERSTOOD);
							reply.setContent("No he entendido el contenido");
						}
					} else {
						System.out.println("Azafata: No entiendo, soy rubia");
						reply.setPerformative(ACLMessage.NOT_UNDERSTOOD);
						reply.setContent("( (Unexpected-act "
								+ ACLMessage.getPerformative(msg
										.getPerformative())
								+ ") ( expected (query-ref :content ping)))");
					}
					send(reply);
				}
			} 
		}

		public boolean done() {
			return finished;
		}
	}

	protected void setup() {
		addBehaviour(new ComienzoAzafata());
	}
}
