import jade.core.AID;
import jade.core.Agent;
import jade.core.AgentContainer;
import jade.core.behaviours.OneShotBehaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.domain.AMSService;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.FIPAAgentManagement.SearchConstraints;
import jade.lang.acl.ACLMessage;
import jade.wrapper.AgentController;


public class Capitan extends Agent {
	
	AMSAgentDescription[] agents;
	
	protected void setup()
	{
		agents = null;

		try {
			SearchConstraints c = new SearchConstraints();
			c.setMaxResults(new Long(-1));
			agents = AMSService.search(this, new AMSAgentDescription(), c);
		} catch (Exception e) {
			;
		}
		addBehaviour(new Bienvenida());
	}
	
	protected class Bienvenida extends OneShotBehaviour 
	{
		public void action() {
			System.out.println("Capitán: Bienvenidos al vuelo TAIA con numero 20152016, espero que disfruten del viaje");
			
			ACLMessage mensaje = new ACLMessage(ACLMessage.INFORM);
			mensaje.setContent("Comienzo");
			mensaje.setSender(getAID());
			for(AMSAgentDescription a:agents)
			{
				mensaje.addReceiver(a.getName());
			}
			send(mensaje);
			doDelete();
		}
	}
	
	protected void takeDown()
	{
		System.out.println("Capitán: Yo cierro la puerta, y a lo mío.");
	}
}
