import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.domain.AMSService;
import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.FIPAAgentManagement.SearchConstraints;
import jade.lang.acl.ACLMessage;

public class JohnMcClane extends Agent {
	
	AMSAgentDescription[] agents;
	
	protected void setup()
	{
		agents = null;

		try {
			SearchConstraints c = new SearchConstraints();
			c.setMaxResults(new Long(-1));
			agents = AMSService.search(this, new AMSAgentDescription(), c);
		} catch (Exception e) {
			;
		}
		addBehaviour(new ThreeStepBehaviour());
	}
	
	public class ThreeStepBehaviour extends Behaviour
	{
		int step;
		
		public void onStart()
		{
			step = 1;
		}
		
		public void action() 
		{
			switch(step)
			{
				case 1:
					if(listenToTerrorist("Terrorist1") == true)
					{
						System.out.println("John McClane: Ya empezamos, otro día en el paraíso");
						step++;
					}
					break;
				case 2:
					if(listenToTerrorist("Terrorist2") == true)
					{
						System.out.println("John McClane: Suelta el detonador!");
						step++;
					}
					break;
				case 3:
					if(listenToTerrorist("Terrorist3") == true)
					{
						System.out.println("John McClane dispara al terrorista...");
						System.out.println("John McClane: Yipi ka yei, hijo de puta");
						ACLMessage mensaje = new ACLMessage(ACLMessage.INFORM);
						mensaje.setContent("disparo");
						mensaje.setSender(getAID());
						for(AMSAgentDescription a:agents)
						{
							mensaje.addReceiver(a.getName());
						}
						send(mensaje);
						done();
					}
					break;
			}
		}

		public boolean done() {
			return false;
		}
		
		private Boolean listenToTerrorist(String cont)
		{
			ACLMessage msg = receive();
			if (msg != null) 
			{
				if (msg.getPerformative() == ACLMessage.INFORM) 
				{
					String content = msg.getContent();
					if ((content != null)
							&& (content.indexOf(cont) != -1)) 
					{
						return true;
					} 
				}
			}
			return false;
		}
		
	}
	
}
