import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.domain.AMSService;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.FIPAAgentManagement.SearchConstraints;
import jade.lang.acl.ACLMessage;

public class Melendi extends Agent {

	protected int state;
	protected AID azafataName;

	/*
	 * Estados: 0 con ganas de pedir 1 Esperando respuesta 2 Durmiendo
	 */

	protected void setup() {
		state = 0;

		// Conseguimos todos los agentes...
		AMSAgentDescription[] agents = null;

		try {
			SearchConstraints c = new SearchConstraints();
			c.setMaxResults(new Long(-1));
			agents = AMSService.search(this, new AMSAgentDescription(), c);
		} catch (Exception e) {
			;
		}
		// hacemos una busqueda de la azafata
		AID myID = getAID();
		for (int i = 0; i < agents.length; i++) {
			AID agentID = agents[i].getName();
			if (agentID.getName().indexOf("azafata") != -1) {
				this.azafataName = agentID;
			}
		}

		addBehaviour(new ComienzoMelendi());
	}

	class ComienzoMelendi extends SimpleBehaviour
	{
		public void action()
		{
			ACLMessage msg = receive();
			if (msg != null) 
			{
				if (msg.getPerformative() == ACLMessage.INFORM) 
				{
					String content = msg.getContent();
					if ((content != null)
							&& (content.indexOf("Comienzo") != -1)) 
					{
						addBehaviour(new AskForDrinkBehaviour(this.getAgent(), azafataName));
					} 
				}
			}
		}

		public boolean done() {
			return true;
		}
	} 
	
	protected class AskForDrinkBehaviour extends CyclicBehaviour {
		AID aName;
		int chupitCount;

		public AskForDrinkBehaviour(Agent a, AID azafataName) {
			super(a);
			aName = azafataName;
			chupitCount = 0;
		}

		public void action() {
			if (state == 0) 
			{
				ACLMessage mensaje = new ACLMessage(ACLMessage.QUERY_REF);
				mensaje.setProtocol(FIPANames.InteractionProtocol.FIPA_QUERY);
				mensaje.setContent("¿Tengo la reserva?");
				mensaje.setSender(getAID());
				mensaje.addReceiver(aName);
				if (chupitCount < 5)
				{
					mensaje.setContent("Chupito");
					System.out.println("Melendi: Asafataaaaa!!! Un chupito de Jagger!!");
				}
				else
				{
					mensaje.setContent("Xupitorrll");
					System.out.println("Melendi: Asfata, ond xupto de jagga!!");
				}
				state = 1; // Cambiar estado a Esperando respuesta
				send(mensaje);
			} 
			else if (state == 1) 
			{
				ACLMessage msg = receive();
				if (msg != null) {
					if (msg.getPerformative() == ACLMessage.NOT_UNDERSTOOD) 
					{
						System.out.println("Melendi: JOrrrl, voy a dormir un rato");
						addBehaviour(new SleepBehaviour(this.myAgent, 12000,this));
						block();
					} 
					else 
					{
						if (msg.getPerformative() == ACLMessage.INFORM) {
							String content = msg.getContent();
							if ((content != null)
									&& (content.indexOf("Chupito") != -1)) {
								// Recibido un INFORM con contenido correcto
								System.out
										.println("Melendi: Pa'rriba, Pa'bajo, Pa'l centro, y pa'dentro!");
								chupitCount++;
							} else {
								System.out.println("Esto no debería ocurrir: Content diferente en inform desde azafata");
							}
						} 
						state = 0;
					}
				}
			}
			/*else if(state == 2)
			{
				System.out.println("Deberia estar bloqueado....");
			}*/
		}
	}
	
	protected class SleepBehaviour extends WakerBehaviour {
		
		AskForDrinkBehaviour bhv;
		
		public SleepBehaviour(Agent a, long timeout, AskForDrinkBehaviour b) {
			super(a, timeout);
			bhv = b;
			state = 2;
		}

		//Despertó!!
		protected void onWake()
		{
			state = 0;
			bhv.chupitCount = 0;
			System.out.println("Melendi: Vaya siesta me he echado, tengo sed!");
			bhv.restart();
		}
			
	}
}
