import jade.core.Agent;
import jade.core.behaviours.OneShotBehaviour;
import jade.core.behaviours.SequentialBehaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.domain.AMSService;
import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.FIPAAgentManagement.SearchConstraints;
import jade.lang.acl.ACLMessage;

public class Terrorist extends Agent {

	AMSAgentDescription[] agents;
	
	public void setup()
	{
		agents = null;

		try {
			SearchConstraints c = new SearchConstraints();
			c.setMaxResults(new Long(-1));
			agents = AMSService.search(this, new AMSAgentDescription(), c);
		} catch (Exception e) {
			;
		}
		
		addBehaviour(new ComienzoTerrorist());
	}
	
	class ComienzoTerrorist extends SimpleBehaviour
	{
		public void action()
		{
			ACLMessage msg = receive();
			if (msg != null) 
			{
				if (msg.getPerformative() == ACLMessage.INFORM) 
				{
					String content = msg.getContent();
					if ((content != null)
							&& (content.indexOf("Comienzo") != -1)) 
					{
						TerrorSeqBehaviour seq = new TerrorSeqBehaviour();
						seq.addSubBehaviour(new disimular(seq,"Terrorista: Leyendo el periodico... Página 1.",0));
						seq.addSubBehaviour(new disimular(seq,"Terrorista: Leyendo el periodico... Página 15.",0));
						seq.addSubBehaviour(new disimular(seq,"Terrorista: Leyendo el periodico... Página 36.",0));
						seq.addSubBehaviour(new disimular(seq,"Terrorista: Leyendo el periodico... Página 40.",0));
						seq.addSubBehaviour(new disimular(seq,"Terrorista: Leyendo el periodico... Página 65.",0));
						seq.addSubBehaviour(new disimular(seq,"Terrorista: Voy al baño a prepararme",28000));
						seq.addSubBehaviour(new Terror(seq,1,"Terrorista: Os voy a volar a todos, infieles!",0));
						seq.addSubBehaviour(new Terror(seq,2,"El terrorista muestra su chaleco lleno de dinamita",0));
						seq.addSubBehaviour(new Terror(seq,3,"El terrorista ha intención de darle al detonador",0));
						
						addBehaviour(seq);
					} 
				}
			}
		}

		public boolean done() {
			return true;
		}
	} 
	
	protected class TerrorSeqBehaviour extends SequentialBehaviour
	{
		public int onEnd()
		{
			System.out.println("Terrorista: ¡Por fin iré al paraíso! Allí me espera un harén de mozas");
			return 0;
		}
	}
	
	protected class disimular extends OneShotBehaviour
	{
		TerrorSeqBehaviour sb;
		String act;
		long ms;
		
		public disimular(TerrorSeqBehaviour sb, String act, long ms){
			this.sb = sb;
			this.act = act;
			this.ms = ms;
		}
		
		public void action()
		{
			System.out.println(act);
			if(ms > 0)
			{
				sb.block(ms);
			}
		}
	}
	
	protected class Terror extends OneShotBehaviour
	{
		TerrorSeqBehaviour sb;
		String act;
		long ms;
		int n;
		
		public Terror(TerrorSeqBehaviour sb, int n, String act, long ms){
			this.sb = sb;
			this.act = act;
			this.ms = ms;
			this.n = n;
		}
		
		public void action()
		{
			System.out.println(act);
			ACLMessage mensaje = new ACLMessage(ACLMessage.INFORM);
			mensaje.setSender(getAID());
			for(AMSAgentDescription a:agents)
			{
				mensaje.addReceiver(a.getName());
			}
			switch(n)
			{
				case 1:
				{
					mensaje.setContent("Terrorist1");
					break;
				}
				case 2:
				{
					mensaje.setContent("Terrorist2");
					break;
				}
				case 3:
				{
					mensaje.setContent("Terrorist3");
					break;
				}
			}
			send(mensaje);
			if(ms > 0)
			{
				sb.block(ms);
			}
		}
	}
}
